#!/usr/bin/python3

from PIL import Image
import pyvisa as visa
#_load_lib(pyvisa)
import os
import sys

def GetByte():
    a=i11801.read_bytes(1)
    return ord(a)

def GetData():
    defaultPalette = [(0,0,0),(77,77,77),(140,140,140),(160,32,240),(255,255,200),(0,255,0),(0,255,255),(255,255,255)]
    xRes = 552
    yRes = 704
    pixLeft = totPix = xRes * yRes # Total pixels we'll acquire
    pixList = [] # List of typles with pixel descriptors

    print("Receiving data (0%)")
    print("Beginning screen capture.\n")
    count = 500
    img = Image.new('RGB', (xRes, yRes), "black")
    pixels = img.load()
    x_pix = 0
    y_pix = 0
    while pixLeft > 0:
        b1 = GetByte()
        pix0 = b1 & 0x07
        pix1 = (b1 >> 3) & 0x07
        rpt = (b1 >> 6)
        if rpt == 0: # Repeat count actually in next byte
            rpt = GetByte()
            if rpt == 0: # Not supposed to happen
                print("Invalid data received. Continuing anyway.\n")
                #self.state = self.WaitForHeader
                #return 0
            if rpt < 4: # Repeat count >255, LSB in next byte
                rpt = (rpt << 8) + GetByte()
        pixList.append((pix0,pix1,rpt))
        pixLeft -= rpt*2

        if len(pixList) == count or pixLeft == 0: # Send a block over to the GUI
            count += 500
            pd = round(float(totPix-pixLeft)/float(totPix) * 100)
            print("Receiving data (%d%%)" % pd)
        pltl = min(2*rpt, xRes-x_pix)
        for i in range(x_pix,x_pix+pltl):
            pixels[i,y_pix]=defaultPalette[pix0]
        end = min(x_pix+pltl+1, xRes)
        for i in range(x_pix+1,end):
            pixels[i,y_pix]=defaultPalette[pix1]
        x_pix += pltl
        if x_pix >= xRes:
            x_pix = 0
            y_pix += 1

    print("Screen capture finished.\n")
    img.show()
    img.save(fname)
    return 0

if len(sys.argv) < 3:
    print("Usage: %s <com port> <image name>.png"%sys.argv[0])
    sys.exit(0)

addr  = sys.argv[1]
fname = sys.argv[2]

rm = visa.ResourceManager(r"c:\Windows\System32\visa32.dll")

print(rm.list_resources())
                       
i11801=rm.open_resource('GPIB0::'+str(addr)+'::INSTR')
i11801.timeout = 10000
b=i11801.query("ID?")
print(b)

i11801.write_termination = '\n'
i11801.read_termination = '\n'
i11801.clear()

print("Initiating Hard Copy")

i11801.write('COP ')
strn=i11801.read()
print(strn)

#strn = i11801.read_ascii_values()

#strn = ser.readline().decode('utf-8').strip()
                          
#print("Instrument type and Date: %s"%strn)
                          
#xsz = ser.readline().decode('utf-8').strip()
xsz =  i11801.read()
print(xsz)

#ysz = ser.readline().decode('utf-8').strip()
ysz= i11801.read()
print(ysz)
                          
#print("Image Size: %s x %s\n"%(xsz,ysz))
GetData()
print("Image saved to %s"%fname)

                        



